ccc;

% aux variables
width = 1936;
height = 1100;
offset = 48;
stride = width + offset;

% load binary data
bytes = read_bytes("data/nvbuffer_rgba.bin");
N = size(bytes,1);

% extract channels
R = bytes(1:4:N);
G = bytes(2:4:N);
B = bytes(3:4:N);
A = bytes(4:4:N);

% reshape as image
R = reshape(R, stride, height)';
B = reshape(B, stride, height)';
G = reshape(G, stride, height)';
A = reshape(A, stride, height)';

% create 3-ch image (without stride offset)
rgb = uint8(zeros(height, width, 3));
rgb(:,:,1) = R(1:height, 1:width);
rgb(:,:,2) = G(1:height, 1:width);
rgb(:,:,3) = B(1:height, 1:width);

% visualize frame
imshow(rgb);